<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'CardBlock',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <SlpContainer class="container">
    <div class="content">
      <div class="eyebrow" />
      <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-32">
        {{ data.header }}
      </SlpTypography>
      <div class="flex">
        <SlpTypography tag="p" variant="body1">
          {{ data.subheader }}
        </SlpTypography>
        <SlpButton
          variant="tertiary"
          :href="data.button.href"
          :data-ga-name="data.button.dataGaName"
          :data-ga-location="data.button.dataGaLocation"
        >
          {{ data.button.text }}
          <SlpIcon
            class="learn-more-icon"
            name="chevron-lg-right"
            variant="product"
          />
        </SlpButton>
      </div>
    </div>
    <SlpRow class="flex">
      <SlpColumn
        v-for="card in data.cards"
        :key="card.header"
        :cols="4"
        class="card"
      >
        <img
          class="image"
          :src="`${card.image.src}?w=350`"
          :alt="card.image.alt"
        />
        <div class="quote-container">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            width="33"
            height="28"
            viewBox="0 0 33 28"
            fill="none"
          >
            <path
              d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
              fill="#171321"
            />
          </svg>
          <SlpTypography class="quote" tag="p" variant="quotes">
            {{ card.title }}"</SlpTypography
          >
          <div class="author">
            <SlpTypography
              v-if="card.subtitle"
              tag="p"
              variant="body2-bold"
              class="slp-mt-32"
            >
              {{ card.subtitle }}</SlpTypography
            >
            <SlpTypography v-if="card.job" tag="p" variant="body2">
              {{ card.job }},</SlpTypography
            >
            <SlpTypography v-if="card.location" tag="p" variant="body2">
              {{ card.location }}</SlpTypography
            >
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.container {
  margin-bottom: 64px;
}
.eyebrow {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
  margin-bottom: $spacing-16;
}
.content {
  padding-top: 96px;
  margin-bottom: 32px;

  p {
    flex: 1 0 70%;
    display: block;
  }

  .slp-btn {
    flex-grow: 1;

    &-tertiary {
      padding-bottom: 0;
      padding-right: 0;
    }
  }
}

.flex {
  display: flex;
  justify-content: space-between;
  gap: 32px;
  flex-wrap: wrap;
}

.quote-container {
  border-radius: 8px;
  background: $color-surface-800;
  padding: 32px;
  height: 100%;
  display: flex;
  flex-direction: column;
  max-height: 460px;

  @media (max-width: $breakpoint-md) {
    display: block;
    max-height: auto;
    height: auto;
  }

  svg {
    margin-bottom: 24px;
  }
}

.author {
  margin: auto 0 0 0;
}
.card {
  background: #f6f3fe;
  border-radius: 4px;
  flex: 1 1 0;

  @media (max-width: $breakpoint-md) {
    margin-bottom: 24px;
    &:not(:last-of-type) {
      margin-bottom: 16px;
    }
  }

  &__wrapper {
    padding: $spacing-32;
  }
}
.image {
  border-radius: 4px 4px 0 0;
  width: 100%;
  height: 210px;
  object-fit: cover;
}
</style>
